<?php

function lzsyscloud_postcurl($urladdress, $fields) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $urladdress);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($fields));
    $content = curl_exec($ch);
    curl_close($ch);
    //return iconv("GB2312", "UTF-8", $content);
    return $content;
} 
function lzsyscloud_getcurl_bak($urladdress, $fields) {
    $urlfields = "";
    foreach ($fields as $k => $v) {
        $urlfields .= $k . "=" . $v . "&";
    } 
    $url = rtrim($urladdress . "?" . $urlfields, "&");
    $header = ["HostAPI: idcsmart.com", "HostAPIIP: " . $_SERVER["SERVER_ADDR"], "HostAPISITE: " . $_SERVER["HTTP_HOST"]];
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    $content = curl_exec($ch);
    curl_close($ch);
    //return iconv("GB2312", "UTF-8", $content);
    return $content;
}
function lzsyscloud_number($length = 3) {
    $characters = '0123456789';
    $password = '';
    
    for ($i = 0; $i < $length; $i++) {
        $randomIndex = mt_rand(0, strlen($characters)-1);
        $password .= $characters[$randomIndex];
    }
    
    return $password;
}
function lzsyscloud_daxie($length = 3) {
    $characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $password = '';
    
    for ($i = 0; $i < $length; $i++) {
        $randomIndex = mt_rand(0, strlen($characters)-1);
        $password .= $characters[$randomIndex];
    }
    
    return $password;
}
function lzsyscloud_xiaoxie($length = 3) {
    $characters = 'abcdefghijklmnopqrstuvwxyz';
    $password = '';
    
    for ($i = 0; $i < $length; $i++) {
        $randomIndex = mt_rand(0, strlen($characters)-1);
        $password .= $characters[$randomIndex];
    }
    
    return $password;
}
function lzsyscloud_getcurl($urladdress, $fields,$params=null) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $urladdress."?".http_build_query($fields)."&osid=".$params['configoptions']['osid']);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($fields)."&osid=".$params['configoptions']['osid']);
    $content = curl_exec($ch);
    curl_close($ch);
    //return iconv("GB2312", "UTF-8", $content);
    return $content;
} 
function lzsyscloud_MetaData() {
    return ["DisplayName" => "乐众系统云服务器对接", "APIVersion" => "1.0.0", "HelpDoc" => "http://www.lzsys.com/"];
} 
function lzsyscloud_ConfigOptions() {
    return [
	["type" => "radio","name" => "弹性模式选择", "description" => "默认不开启弹性模式,弹性模式目前仅支持套餐弹性,若开启则需填写可配置选项,具体见帮助文档", "options" => "开启弹性模式,不开启弹性模式","default" => "不开启弹性模式", "key" => "tx"], 
	["type" => "text", "name" => "VPS产品ID","description" => "请填写商品编号","key" => "productid"], 
	//["type" => "text","name" => "星外免费试用时间", "description" => "对应财务的免费、小时付款、免费试用，星外免费试用费率固定，请勿更改", "default" => "999","key" => "hourfree"], 
	//["type" => "text", "name" => "星外日付时间", "description" => "不支持日付", "key" => "day"], 
	["type" => "text", "name" => "月付时间", "description" => "月付请填 1", "key" => "month"], 
	["type" => "text", "name" => "季付时间", "description" => "季付填3", "key" => "3month"], 
	["type" => "text", "name" => "半年付时间", "description" => "半年填6", "key" => "6month"], 
	["type" => "text", "name" => "年付时间", "description" => "1年填 1y", "key" => "12month"], 
	["type" => "text", "name" => "两年付时间", "description" => "2年填 2y", "key" => "24month"], 
	["type" => "text", "name" => "三年付时间", "description" => "3年填 3y", "key" => "36month"], 
	["type" => "text", "name" => "默认机房ID", "description" => "请填写默认机房ID，不清楚可为空，若开通出错请填写产品的对应机房ID", "key" => "osnum"], 
	["type" => "text", "name" => "默认镜像文件名称", "description" => "请联系客服获取镜像名称", "key" => "osid"], 
	["type" => "text", "name" => "VPS控制面板地址", "description" => "控制面板地址，请联系上级获取", "key" => "vpscontrol"], 
	["type" => "text", "name" => "备注", "description" => "用于前台显示", "key" => "note"]
	];
} 
function lzsyscloud_TestLink(array $params) {
    if (substr($params["server_ip"], -1) == "/") {
        $params["server_ip"] = substr($params["server_ip"], 0, -1);
    } 
    $tempcurl = lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "vpsname" => "", "action" => "getinfo"]);
    if ($tempcurl == "auth_error") {
        $result["status"] = 200;
        $result["data"]["server_status"] = 1;
    } elseif ($tempcurl == "userstrs error") {
        $result["status"] = 200;
        $result["data"]["server_status"] = 0;
        $result["data"]["msg"] = "接口密钥错误";
    }elseif ($tempcurl == "api status is off") {
        $result["status"] = 200;
        $result["data"]["server_status"] = 0;
        $result["data"]["msg"] = "接口处于关闭状态，请到上级平台开启";
    }elseif ($tempcurl == "userid error") {
        $result["status"] = 200;
        $result["data"]["server_status"] = 0;
        $result["data"]["msg"] = "接口接口账号错误";
    } else {
        $result["status"] = 200;
        $result["data"]["server_status"] = 0;
        $result["data"]["msg"] = $tempcurl;
    } 
    return $result;
} 
function lzsyscloud_CreateAccount($params) {
    if (substr($params["server_ip"], -1) == "/") {
        $params["server_ip"] = substr($params["server_ip"], 0, -1);
    } 
    $BuyYear = lzsyscloud_buyyearjs($params);
    if (!$BuyYear) {
        return "购买年限计算失败";
    } 
    if (@$params["configoptions"]["idcid"]) {
        $idcid = $params["configoptions"]["idcid"];
    } else {
        if (@$params["configoption15"]) {
            $idcid = trim($params["configoption15"]);
        } else {
            $idcid = "1";
        } 
    } 
    if (@$params["configoptions"]["osnum"]) {
        $osnum = $params["configoptions"]["osnum"];
    } else {
        if (@$params["configoption14"]) {
            $osnum = trim($params["configoption14"]);
        } else {
            $osnum = "1";
        } 
    } 
    $params['host_passwordz'] = lzsyscloud_number().lzsyscloud_xiaoxie().lzsyscloud_daxie();
    if ($params["configoptions"]["tx"] == "不开启弹性模式") {
        $tempcurl = lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "year" => $BuyYear, "idc" => $idcid, "productid" => $params["configoptions"]["productid"], "OSAllList" => $osnum, "action" => "activate","vpsname"=>$params['domain'],"api_iso"=>$params['osid'],"VPSpassword"=>$params['host_passwordz']],$params);
    } else {
        $tempcurl = lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "year" => $BuyYear, "idc" => $idcid, "productid" => $params["configoptions"]["planid"], "OSAllList" => $osnum, "action" => "activate","vpsname"=>$params['domain'],"api_iso"=>$params['osid'],"VPSpassword"=>$params['host_passwordz']],$params);
    } 
    $temp = lzsyscloud_contrim($tempcurl);
    if (empty($temp)) {
        return "未返回信息，创建失败";
    } 
    if (@$temp["ret"] != "ok") {
        if (!$temp["freehosinfo"]) {
            $errormsg = "错误信息：".$tempcurl;
        } else {
            $errormsg = $temp["freehosinfo"].$tempcurl;
        } 
        return $errormsg;
    } 
    if ($temp["vpsname"]) {
        $update["username"] = $temp["vpsname"];
        $update["domain"] = "CloudServer-" . $temp["vpsname"];
        \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    } 
    if ($temp["vpspassword"]) {
        $update["password"] = cmf_encrypt($temp["vpspassword"]);
        \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    } 
    $update["dedicatedip"] = $temp["ip"];
    \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    $description = sprintf("实例创建成功 - Host ID:%d", $params["hostid"]);
    active_logs($description, $params["uid"], 2);
    active_logs($description, $params["uid"], 2, 2);
    return "success";
} 
function lzsyscloud_Sync($params) {
    if (substr($params["server_ip"], -1) == "/") {
        $params["server_ip"] = substr($params["server_ip"], 0, -1);
    } 
    $tempcurl = lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "vpsname" => $params["username"], "action" => "getinfo"]);
    $temp = lzsyscloud_contrim($tempcurl);
    if (empty($temp)) {
        return "未返回信息，查询失败";
    } 
    if (@$temp["ret"] != "ok") {
        if (!$temp["freehosinfo"]) {
            $errormsg = "未知错误";
        } else {
            $errormsg = $temp["freehosinfo"];
        } 
        return $errormsg;
    } 
    if ($temp["vpsname"]) {
        $update["username"] = $temp["vpsname"];
        $update["domain"] = "CloudServer-" . $temp["vpsname"];
        \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    } 
    if ($temp["vpspassword"]) {
        $update["password"] = cmf_encrypt($temp["vpspassword"]);
        \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    } 
    $porttts = str_replace(":", "&port=", $temp["ip"]);
    $checkip = substr_replace($porttts, "&ip=", 0, 0);
    $ipout = lzsyscloud_contrim($checkip);
    $update["dedicatedip"] = $ipout["ip"];
    $ip = $temp["ip"];
    $porttt = str_replace(":", "&port=", $temp["ip"]);
    $ports = lzsyscloud_contrim($porttt);
    $portss = $ports["port"];
    $update["port"] = $portss;
    \think\Db::name("host")->where("id", $params["hostid"])->update($update);
    $description = sprintf("同步指令下发成功 - Host ID:%d", $params["hostid"]);
    active_logs($description, $params["uid"], 2);
    active_logs($description, $params["uid"], 2, 2);
    return "success";
} 
function lzsyscloud_Renew($params) {
    if (substr($params["server_ip"], -1) == "/") {
        $params["server_ip"] = substr($params["server_ip"], 0, -1);
    } 
    $BuyYear = lzsyscloud_buyyearjs($params);
    if (!$BuyYear) {
        return "续费年限计算失败";
    } 
    $tempcurl = lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "year" => $BuyYear, "vpsname" => $params["username"], "action" => "renew"]);
    $temp = lzsyscloud_contrim($tempcurl);
    if (empty($temp)) {
        return "服务器连接失败....";
    } 
    if (@$temp["ret"] != "ok") {
        if (!$temp["freehosinfo"]) {
            $errormsg = "未知错误";
        } else {
            $errormsg = $temp["freehosinfo"];
        } 
        return $errormsg;
    } 
    $description = sprintf("续费指令下发成功 - Host ID:%d", $params["hostid"]);
    active_logs($description, $params["uid"], 2);
    active_logs($description, $params["uid"], 2, 2);
    return "success";
} 
function lzsyscloud_SuspendAccount($params) {
    return ["status" => "success", "msg" => "当前仅支持在财务暂停,不支持同步暂停"];
} 
function lzsyscloud_UnSuspendAccount($params) {
    return ["status" => "success", "msg" => "当前仅支持在财务解除暂停,不支持同步解除暂停"];
} 
function lzsyscloud_TerminateAccount($params) {
    return ["status" => "success", "msg" => "当前仅支持在财务删除,不支持同步删除"];
} 
function lzsyscloud_gethashinfo($data) {
    preg_match_all("/<(.*?)>([^<]+)<\\/\\1>/i", $data, $matches);
    $result = [];
    foreach ($matches[1] as $k => $v) {
        $result[$v] = $matches[2][$k];
    } 
    return $result;
} 
function lzsyscloud_buyyearjs($params) {
    $billingcycle = $params["billingcycle"];
    if (!$billingcycle) {
        return false;
    } 
    switch ($billingcycle) {
        case "onetime":
            if (!@$params["configoptions"]["month"]) {
                $hostingcycle = "0.084";
            } else {
                $hostingcycle = trim($params["configoptions"]["month"]);
            } 
            break;
        case "ontrial":
            if (!@$params["configoptions"]["hourfree"]) {
                $hostingcycle = "999";
            } else {
                $hostingcycle = trim($params["configoptions"]["hourfree"]);
            } 
            break;
        case "free":
            if (!@$params["configoptions"]["hourfree"]) {
                $hostingcycle = "999";
            } else {
                $hostingcycle = trim($params["configoptions"]["hourfree"]);
            } 
            break;
        case "hour":
            if (!@$params["configoptions"]["hourfree"]) {
                $hostingcycle = "999";
            } else {
                $hostingcycle = trim($params["configoptions"]["hourfree"]);
            } 
            break;
        case "day":
            if (!@$params["configoptions"]["day"]) {
                $hostingcycle = "0.084";
            } else {
                $hostingcycle = trim($params["configoptions"]["day"]);
            } 
            break;
        case "monthly":
            if (!@$params["configoptions"]["month"]) {
                $hostingcycle = "0.084";
            } else {
                $hostingcycle = trim($params["configoptions"]["month"]);
            } 
            break;
        case "quarterly":
            if (!@$params["configoptions"]["3month"]) {
                $hostingcycle = "0.25";
            } else {
                $hostingcycle = trim($params["configoptions"]["3month"]);
            } 
            break;
        case "semiannually":
            if (!@$params["configoptions"]["6month"]) {
                $hostingcycle = "0.5";
            } else {
                $hostingcycle = trim($params["configoptions"]["6month"]);
            } 
            break;
        case "annually":
            if (!@$params["configoptions"]["12month"]) {
                $hostingcycle = "1";
            } else {
                $hostingcycle = trim($params["configoptions"]["12month"]);
            } 
            break;
        case "biennially":
            if (!@$params["configoptions"]["24month"]) {
                $hostingcycle = "2";
            } else {
                $hostingcycle = trim($params["configoptions"]["24month"]);
            } 
            break;
        case "triennially":
            if (!@$params["configoptions"]["36month"]) {
                $hostingcycle = "3";
            } else {
                $hostingcycle = trim($params["configoptions"]["36month"]);
            } 
            break;
        default:
            return false;
    } 
    return $hostingcycle;
} 
function lzsyscloud_contrim($Info) {
    $Infoexparr = explode("&", $Info);
    $InfoArray = [];
    foreach ($Infoexparr as $Info2array) {
        $Info2exparr = explode("=", $Info2array);
        if (!$Info2exparr[0]) {
            continue;
        } 
        if ($Info2exparr[1] == null) {
            $Info2exparr[1] = null;
        } 
        $InfoArray[$Info2exparr[0]] = $Info2exparr[1];
    } 
    return $InfoArray;
} 
function lzsyscloud_ClientArea($params) {
    return ["information" => ["name" => "产品详情"]];
} 
function lzsyscloud_ClientAreaOutput($params, $key) {
    $temp = lzsyscloud_contrim(lzsyscloud_getcurl($params["server_ip"] . "/api/cloudapi.asp", ["userid" => $params["server_username"], "userstr" => md5($params["server_password"] . "7i24.com"), "vpsname" => $params["username"], "action" => "getinfo"]));
    if ($key == "information") {
        return ["template" => "templates/information.html", "vars" => ["product_name" => $params["name"], "address" => $params["server_host"], "username" => $temp["vpsname"], "password" => $temp["vpspassword"], "ip" => $temp["ip"], "status" => $temp["status"], "note" => $params["configoptions"]["note"], "vpscontrol" => $params["configoptions"]["vpscontrol"]]];
    } 
} 
